package classes;

import java.util.ArrayList;

public class HolonObject extends CpsObject {

	/* Array of all consumers */
	private ArrayList<HolonElement> consumers;
	/* Array of all producers */
	private ArrayList<HolonElement> producers;
	/* Total of consumption */
	private float currentEnergy;
	/**
	 * State of the building: 0 = fully supplied (currentEnergy == 0) 1 = not
	 * enough energy (currentEnergy > 0) 2 = oversupplied (currentEnergy < 0)
	 */
	int state;

	/**
	 * Constructor Set by default the name of the object equals to the category
	 * name, until the user changes it.
	 */
	public HolonObject(String ObjName) {
		super(ObjName);
		consumers = new ArrayList<HolonElement>();
		producers = new ArrayList<HolonElement>();
	}

	public HolonObject(String ObjName, String obj) {
		super(ObjName);
		super.name = obj;
		consumers = new ArrayList<HolonElement>();
		producers = new ArrayList<HolonElement>();
	}

	public HolonObject(CpsObject obj) {
		super(obj);
		consumers = new ArrayList<HolonElement>();
		producers = new ArrayList<HolonElement>();
		this.consumers = ((HolonObject)obj).getConsumers();
		this.producers = ((HolonObject)obj).getProducers();
	}

	public void addConsumer(HolonElement consumer) {
		consumers.add(consumer);
	}

	public void addProducer(HolonElement producer) {
		producers.add(producer);
	}

	public void deleteConsumer(int idx) {
		consumers.remove(idx);
	}

	public void deleteProducer(int idx) {
		producers.remove(idx);
	}

	public float calculateCurrentEnergy() {
		return currentEnergy;
	}

	public ArrayList<HolonElement> getConsumers() {
		return consumers;
	}

	public void setConsumers(ArrayList<HolonElement> consumers) {
		this.consumers = consumers;
	}

	public ArrayList<HolonElement> getProducers() {
		return producers;
	}

	public void setProducers(ArrayList<HolonElement> producers) {
		this.producers = producers;
	}

	/**
	 * String of all consumers in this HolonObject
	 * 
	 * @return all the names of this HolonObject separated by "," each object
	 */
	public String toStringConsumers() {
		String objString = "";
		for (HolonElement e : consumers) {
			if (objString == "") {
				objString = e.getName();
			} else {
				objString = objString + ", " + e.getName();
			}

		}
		return objString;
	}

	/**
	 * String of all producers in this HolonObject
	 * 
	 * @return all the names of this HolonObject separated by "," each object
	 */
	public String toStringProducers() {
		String objString = "";
		for (HolonElement e : producers) {
			if (objString == "") {
				objString = e.getName();
			} else {
				objString = objString + ", " + e.getName();
			}

		}
		return objString;
	}

}
