package ui.controller;

import ui.model.IdCounter;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedList;

import classes.Category;
import classes.CpsObject;
import Interfaces.CategoryListener;
import ui.model.Model;
import ui.view.GUI;

public class Control {

	public enum command {
		CATEGORY, OBJECT
	}

	private IdCounter iD;
	private Model model;
	private ActionListener actionListener;
	private final CategoryController categoryController;
	private final ObjectControl objectControl;

	public Control(Model model, IdCounter id) {
		this.model = model;
		this.iD = id;
		this.categoryController = new CategoryController(model, id);
		this.objectControl = new ObjectControl(model);
	}

	public void addObject(CpsObject object) {
		objectControl.addObject(object);
	}

	////////// Operations for Categories and Objects ///////////
	public void addNewCategory(String catName) {
		categoryController.addNewCategory(catName);
	}

	public void addNewObject(Category cat, String name, String objType) {
		categoryController.addNewHolonObject(cat, name, objType);
	}

	public void addNewTransformer(Category cat, String name, String objType) {
		categoryController.addNewHolonTransformer(cat, name, objType);
	}

	public void addNewSwitch(Category cat, String name, String objType) {
		categoryController.addNewHolonSwitch(cat, name, objType);
	}

	public Category searchCategory(String name) {

		return categoryController.searchCatNode(name);
	}

	public void initListener(CategoryListener catLis) {
		categoryController.addCatListener(catLis);
	}

	public void deleteCategory(String catName) {
		categoryController.deleteCategory(catName);
	}

	public void deleteObjectInCat(String toDelete, String deleteIn) {
		categoryController.deleteObjectInCat(toDelete, deleteIn);
	}

	////////// etc
	/**
	 * Getter for Model
	 * 
	 * @return
	 */
	public Model getModel() {
		return model;
	}

}
