package ui.controller;

import classes.CpsObject;
import ui.model.IdCounter;
import ui.model.Model;
import Interfaces.ObjectListener;

public class ObjectControl {

	private Model M;
	private int ID;

	public ObjectControl(Model model) {
		this.M = model;
		ID = IdCounter.nextId();
	}

	/**
	 * Add an CpsObject to the model and notify the ObjectListener for update.
	 * 
	 * @param object
	 *            CpsObject to be added.
	 */
	public void addObject(CpsObject object) {
		String name = object.getObjName();
		M.getObjectsOnCanvas().add(object);
		notifyObjListeners();
		System.out.println("Added: " + name);
	}

	/**
	 * notifies all listeners about changes in the Categories
	 */
	public void notifyObjListeners() {
		for (ObjectListener l : M.getObjectListeners()) {
			l.onChange(M.getObjectsOnCanvas());
		}
	}

}
