package ui.view;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Paint;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;
import java.util.LinkedList;

import javax.swing.ImageIcon;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import classes.CpsObject;
import classes.GlobalVariables;
import classes.HolonElement;
import classes.HolonObject;
import ui.model.*;

class MyCanvas extends JPanel implements MouseListener, MouseMotionListener {
	private Image img = null; // Contains the image to draw on MyCanvas
	private int x = 0;
	private int y = 0;
	Model model;
	
	boolean dragging = false;
	boolean dropDelete = false;
	CpsObject tempCps = null;
	Rectangle selectRect = new Rectangle();

	// PopUpMenu
	JPopupMenu popmenu = new JPopupMenu();
	JMenuItem itemDelete = new JMenuItem("Delete Object");

	public MyCanvas(final Model model) {
		this.model = model;
		popmenu.add(itemDelete);
		itemDelete.setEnabled(false);
		itemDelete.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				model.getObjectsOnCanvas().remove(tempCps);
				selectRect.setRect(0, 0, 0, 0);
				repaint();
			}
		});

		//img = new ImageIcon(this.getClass().getResource("/Images/Dummy_House.png")).getImage()
		//		.getScaledInstance(30, 30, java.awt.Image.SCALE_SMOOTH);
		
		this.addMouseListener(this);
		this.addMouseMotionListener(this);
	}

	public void paintComponent(Graphics g) {
		// Draws the image to the canvas
		super.paintComponent(g);
		if(selectRect != null){
			g.setColor(new Color(220, 220, 220));
		    g.fillRect((int)selectRect.getX(), (int)selectRect.getY(), (int)selectRect.getWidth(), (int)selectRect.getHeight());
		}
		
		for (CpsObject cps : model.getObjectsOnCanvas()) {
			img = new ImageIcon(this.getClass().getResource(cps.getImage())).getImage();
			g.drawImage(img, cps.getPos().x, cps.getPos().y, GlobalVariables.SCALE, GlobalVariables.SCALE, null);
			//g.drawImage(img, cps.getPos().x, cps.getPos().y, null);
		}
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		x = e.getX();
		y = e.getY();
		tempCps = null;
		for (CpsObject cps : model.getObjectsOnCanvas()) {
			int cx = cps.getPos().x;
			int cy = cps.getPos().y;
			if (x - GlobalVariables.SCALE <= cx && y - GlobalVariables.SCALE <= cy && x >= cx && y >= cy) {
				tempCps = cps;
			}
		}
		if(tempCps != null){
			selectRect.setBounds(tempCps.getPos().x-(GlobalVariables.SCALE/20), tempCps.getPos().y-(GlobalVariables.SCALE/20), GlobalVariables.SCALE+GlobalVariables.SCALE/10, GlobalVariables.SCALE+GlobalVariables.SCALE/10);
			System.out.println("Select");
		}else {
			selectRect.setRect(0, 0, 0, 0);
			System.out.println("Unselect");
		}
		repaint();		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		if (dragging) {
			x = e.getX();
			y = e.getY();
			dragging = false;
			tempCps.setPos(e.getX() - GlobalVariables.SCALE/2, e.getY() - GlobalVariables.SCALE/2);
			tempCps = null;
			repaint();
		}
		// Rechtsklick Liste
		if (e.getButton() == e.BUTTON3) {
			if (e.getButton() == e.BUTTON3 && tempCps != null) {
				itemDelete.setEnabled(true);
			}else {
				itemDelete.setEnabled(false);
			}
			popmenu.show(e.getComponent(), e.getX(), e.getY());

		}
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
			try {
				tempCps.setPos(e.getX() - GlobalVariables.SCALE/2, e.getY() - GlobalVariables.SCALE/2);
				dragging = true;
				selectRect.setLocation(tempCps.getPos().x-(GlobalVariables.SCALE/20), tempCps.getPos().y-(GlobalVariables.SCALE/20));
				repaint();
				System.out.println("drag: " + e.getX() + " " + e.getY());
			} catch (Exception e2) {
				// TODO: handle exception
			}
	}

	@Override
	public void mouseMoved(MouseEvent e) {
		// TODO Auto-generated method stub

	}
}